try {
	load("nashorn:mozilla_compat.js");
} catch (e) {
	// ignore the exception - perhaps we are running on Rhino!
}

function findBasePeak2(from, to){
	var apexIndex = findapexIndex(from, to);	
	var ms = sample.getMSSpectrum();
	if(apexIndex != -1){
		return ms.getExactMZAtIndex(apexIndex);
	} else {
		return -1;
	}
	
}

function findapexIndex(from, to){
	var low = parseFloat(from);
	var high = parseFloat(to);
	
	// local maximum
	var ms = sample.getMSSpectrum();

	var lowIndex = ms.getMZIndex(low);
	if(lowIndex < 0){
		lowIndex = -lowIndex - 1;
	}
	
	var highIndex = ms.getMZIndex(high);
	if(highIndex < 0){
		highIndex = -highIndex - 1;
	}

	var apexIndex = -1;
	var maxIntensity = 0;
	
	// right apex
	var size = ms.size();
	for(var i = lowIndex; i<size && i < highIndex; i++){
		var curIntensity = ms.getIntensityAtIndex(i);
		if(curIntensity > maxIntensity) {
			apexIndex = i;
			maxIntensity = curIntensity;
		}
	}
	return apexIndex;
}

function findBasePeak3(massListString, tolerance){
	var massList = massListString.split(",");
	var tol = parseFloat(tolerance);
	var ms = sample.getMSSpectrum();
	
	var apexIndexMax = -1;
	for(var i = 0; i < massList.length; i++){
		var mass = parseFloat(massList[i]);
		var apex = findapexIndex(mass-tol, mass+tol);
		if(apex != -1){
			if(apexIndexMax == -1){
				apexIndexMax = apex;
			}else{
				if(ms.getIntensityAtIndex(apex) > ms.getIntensityAtIndex(apexIndexMax)){
					apexIndexMax = apex;
				}
			}
		}
	}
	if(apexIndexMax != -1){
		return ms.getExactMZAtIndex(apexIndexMax);
	} else {
		return -1;
	}
}
